#include<iostream>
using namespace std;
 int main()
 {
 	long long n,m,a,b,c,d,br=0,br1=0;
 	cin>>n>>m;
 	if(n==1){
 		cin>>a>>b;
 		long long niz1[m],br=0;
 		long long niz[m][2];
 		for(long long i=0; i<m; i++){
 			c>>niz[i][0];
 			d>>niz[i][1];
 			if(c<=d)
 			{
 				niz1[i]=c;
 				br=br+c;
 				br1++;
			 }
		 }
		 if(br<b){
		 	long long i=0;
		 	while(br<b)
			 {
		 		if(niz1[i]<niz[i][1])
				 {
		 			niz1[i]++;
		 			br++;
				 }
				 i++;			 
			}
		 }
		 cout<<br<<endl;
		 cout<<br1<<endl;
		 for(long long i=0; i<m; i++){
		 	if(niz1[i]!=0){
		 		cout<<1<<" "<<i+1<<" "<<niz1[i]<<endl;
			 }
		 }
	 }
 	return 0;
}